#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue  
#property indicator_color2 Blue
//---- input parameters
extern string  TimeFrame = "Current time frame";
extern int       A_t3_period    = 18;
extern int       A_t3_price    = PRICE_CLOSE;
extern bool      A_t3_original = false;
extern int       B_t3_period   = 10;
extern int       B_t3_price    = PRICE_CLOSE;
extern bool      B_t3_original = false;
extern double    T3_hot        = 0.7;
extern int       diferential   = 0;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double t31[];
double t32[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,t31);
   SetIndexBuffer(3,t32);
         timeFrame           = stringToTimeFrame(TimeFrame);
         indicatorFileName   = WindowExpertName();
         returnBars          = TimeFrame=="returnBars";
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for(int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);
                  ExtMapBuffer1[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",A_t3_period,A_t3_price,A_t3_original,B_t3_period,B_t3_price,B_t3_original,T3_hot,diferential,0,y);
                  ExtMapBuffer2[i]   = iCustom(NULL,timeFrame,indicatorFileName,"",A_t3_period,A_t3_price,A_t3_original,B_t3_period,B_t3_price,B_t3_original,T3_hot,diferential,1,y);
            }       
            return(0);
         }

   //
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {  
      t31[i]=iT3(iMA(NULL,0,1,0,MODE_SMA,A_t3_price,i),A_t3_period,T3_hot,A_t3_original,i,0);
      t32[i]=iT3(iMA(NULL,0,1,0,MODE_SMA,B_t3_price,i),B_t3_period,T3_hot,B_t3_original,i,1);
      if(diferential==1)
      {
         if (t31[i+1] >0 && t32[i+1]>0) 
         {
            ExtMapBuffer1[i]=(t31[i]-t31[i+1])/t31[i+1]; 
            ExtMapBuffer2[i]=(t31[i]-t31[i+1])/t31[i+1]+(t32[i]-t32[i+1])/t32[i+1]; 
         }
      }         
      else
      {
         if (t31[i+1] >0 && t32[i+1]>0) 
         {
            ExtMapBuffer2[i]=(t32[i]-t32[i+1])/t32[i+1];
            ExtMapBuffer1[i]=(t31[i]-t31[i+1])/t31[i+1];
         }
      }
   }
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}